#include <Wire.h>
#define NUM_PINS 7
#define WHOAMI 21 // 20 for Peripheral 1 and 21 for Peripheral 2
#define NUM_SAMPLES 100
#define THRESHOLD 1000 * NUM_SAMPLES

int pins[NUM_PINS] = {D3, A2, A1, A0, A10, A9, A8};

int baseline[NUM_PINS];
int currValues[NUM_PINS];
bool inUse[NUM_PINS];

void initializeBaseline() {
  for (int p = 0; p<NUM_PINS; p++) {
    baseline[p] = 0;
    for (int i = 0; i<NUM_SAMPLES; i++) {
      baseline[p] += touchRead(pins[p]);
    }
  }
}

void detectInUse() {
  String s = "";
  s += "Detecting\n";
  for (int p = 0; p<NUM_PINS; p++) {
    currValues[p] = 0;
    for (int i = 0; i<NUM_SAMPLES; i++) {
      currValues[p] += touchRead(pins[p]);
    }
    inUse[p] = (currValues[p] > baseline[p] + THRESHOLD);
  }
}

void sendInUse() {
  String s = "";
  for (int p = 0; p<NUM_PINS; p++) {
    s += inUse[p] ? "Y" : "N";
  }
  Wire.write(s.c_str());
}

void setup() {
  Wire.begin(WHOAMI);
  initializeBaseline();
  delay(1000);
  initializeBaseline();
  Wire.onRequest(sendInUse); // register event
}

void loop() {
  detectInUse();
}
